%clc;
tic;
options = odeset('RelTol',1e-3,'AbsTol',1e-4);

M = [25.8 0 0; 0 33.8 1.0115; 0 1.0115 2.76];
k_x_bar = 0.1;
k_y_bar = 0.1;
k_sigma_bar = 0.1;
c_f = 1.7;
c_r = 0.1;
eps_y = 0.01;
eps_sigma = 0.01;
eps = 0.01;
%Initial conditions
y_0 = [1 1 0.5];
x_0 = [0.5 0.5 0];
Syhat_0 = [0.5 1.5 0.6];
r_0 = 0.5;
sigmahat_0 = 0;
etahat_0 = Syhat_0;
xi_0= (x_0'-K_x(0,sigmahat_0,Syhat_0',k_x_bar,c_f,eps_y,eps_sigma,M)*y_0')'+[0.2 0.2 0.1];
etadothat_0 = (L(y_0',M)*(xi_0'+K_x(0,sigmahat_0,Syhat_0',k_x_bar,c_f,eps_y,eps_sigma,M)*y_0'))';
etadot_0 = (L(y_0',M)*(xi_0'+K_x(0,sigmahat_0,Syhat_0',k_x_bar,c_f,eps_y,eps_sigma,M)*y_0'))';
q = [y_0 x_0 Syhat_0 xi_0 r_0 sigmahat_0 etahat_0 etadothat_0]'

% Transformation constants
Ship_velocity = (L(y_0',M)*x_0')'
x_hat = xi_0'+K_x(0,sigmahat_0,Syhat_0',k_x_bar,c_f,eps_y,eps_sigma,M)*y_0'
Real_ship_in_knot = norm(Ship_velocity(1:2))*sqrt(70)*1.94384449
Observer_velocity_in_knot = norm(etadothat_0(1:2))*sqrt(70)*1.94384449

% Main system   
[Tim,Y] = ode23(@ship,[0 3.5],q,options);
toc
Making_the_plots;
