function q_d = ship(t,q)
% persistent y_noise t_cache;
%%% Constants
M = [25.8 0 0; 0 33.8 1.0115; 0 1.0115 2.76];
L_1 = [10 0 0; 0 10 0; 0 0 10];
L_2 = [40 0 0; 0 40 0; 0 0 40];
k_x_bar = 0.1;
k_y_bar = 0.1;
k_sigma_bar = 0.1;
c_f = 1.7;
c_r = 0.1;
eps_y = 0.01;
eps_sigma = 0.01;
eps = 0.01;

%%%%% Initialisations
q_d = zeros(20,1);
y_1 = q(1);
y_2 = q(2);
y_3 = q(3);
x_1 = q(4);
x_2 = q(5);
x_3 = q(6);
y_hat_1 = q(7);
y_hat_2 = q(8);
y_hat_3 = q(9);
xi_1 =q(10);
xi_2 =q(11);
xi_3 =q(12);
r =q(13);
sigma_hat =q(14);
eta_hat = q(15:17);
eta_dot_hat =q(18:20);

%%%%%%Ship Model%%%%%%%%%
y = [y_1 y_2 y_3]';
x = [x_1 x_2 x_3]';
%q_d(1:3) = L(y,M)*1.023*x;% y_dot with bias
%q_d(4:6) = S(t,y,x,M)*1.023*x + F_bias(t,y,x,M); % x_dot with bias
q_d(1:3) = L(y,M)*x;% y_dot
q_d(4:6) = S(t,y,x,M)*x + F(t,y,x,M); % x_dot

%%%%%%Stamnes Observer%%%%%%%%%%

%y_noise = y+diag(-0.005 +rand(3,1)*0.01)*[1 1 0.1]';
y_noise=y; % y without noise
y_hat =[y_hat_1 y_hat_2 y_hat_3]';
xi = [xi_1 xi_2 xi_3]';
x_hat = xi+K_x(t,sigma_hat,y_hat,k_x_bar,c_f,eps_y,eps_sigma,M)*y_noise;
sigma =(norm(x_hat))^2;
y_tilde = y_noise-y_hat;
sigma_tilde =sigma-sigma_hat;

%y_hat_dot
q_d(7:9) = L(y_noise,M)*x_hat + K_y(t,y_noise,y_hat,r,sigma_hat,k_y_bar,k_x_bar,c_f,eps_y,eps_sigma,M)*y_tilde;

% %r_dot
q_d(13) = -(k_x_bar/2)*(r-c_r)+r*(Delta_y_bar(t,y_noise,y_hat,sigma_hat,k_x_bar,c_f,eps_y,eps_sigma,M)*norm(y_tilde)...
    + Delta_sigma_bar(t,y_noise,x_hat,sigma_hat,eps_sigma,M)*norm(sigma_tilde));

%sigma_hat_dot
tau_sigma = 2*(x_hat'*F(t,y_noise,x_hat,M) + k_sigma(t,y_noise,y_hat,x_hat,r,sigma_hat,sigma,k_sigma_bar,k_x_bar,c_f,eps_y,eps_sigma,M)*sigma_tilde);
if(sigma_hat>0 || tau_sigma>= 0)
    q_d(14) = tau_sigma;
else
    q_d(14) = (1-c_sigma(sigma_hat,eps))*tau_sigma
end
%_xi_dot plasseres underst pga m bruke sigma_hat_dot
q_d(10:12) = S(t,y_noise,x_hat,M)*x_hat + F(t,y_noise,x_hat,M) - K_x(t,sigma_hat,y_hat,k_x_bar,c_f,eps_y,eps_sigma,M)*L(y_noise,M)*x_hat...
    - K_x_diff(t,y_hat,sigma_hat,k_x_bar,c_f,eps_y,eps_sigma,M,3)*q_d(9)*y_noise...
    - K_x_diff(t,y_hat,sigma_hat,k_x_bar,c_f,eps_y,eps_sigma,M,4)*q_d(14)*y_noise;


%%%%%%%%Wondergem observer%%%%%%%%%%%
eta_tilde = y_noise-eta_hat;
q_d(15:17) = eta_dot_hat+L_1*eta_tilde;
q_d(18:20) = -inv(M_y(y_noise,M))*(-tau(t,y_noise)+C(y_noise,q_d(15:17),M)*q_d(15:17) + D(y_noise,q_d(15:17))*q_d(15:17)) + L_2*eta_tilde;

% %Testing that c_F i suficiantly large
% saft =(F(t,y_noise,x,M)-F(t,y_noise,x_hat,M))'*(x-x_hat);
% bolle =c_f*norm(x-x_hat)^2;
% if saft>bolle
%     C_F_for_liten =1
% end





